package com.flow.entity.node;

import com.google.common.collect.Lists;
import lombok.Data;
import lombok.EqualsAndHashCode;
import org.flowable.bpmn.model.CallActivity;
import org.flowable.bpmn.model.FlowElement;
import org.flowable.bpmn.model.SequenceFlow;

import java.util.ArrayList;
import java.util.List;
import java.util.Objects;

@EqualsAndHashCode(callSuper = true)
@Data
public class CallNode extends Node{
    private String definitionId;
    @Override
    public List<FlowElement> convert() {
        ArrayList<FlowElement> elements = Lists.newArrayList();
        CallActivity callActivity = new CallActivity();
        callActivity.setId(this.getId());
        callActivity.setName(this.getName());
        callActivity.setExecutionListeners(this.buidEventListener());
        callActivity.setInheritVariables(true);
        callActivity.setInheritBusinessKey(true);
        callActivity.setCalledElementType("id");
        callActivity.setCalledElement(this.definitionId);
        callActivity.setProcessInstanceName(this.getName());
        elements.add(callActivity);
        // 下一个节点的连线
        Node next = this.getNext();
        SequenceFlow sequenceFlow = this.buildSequence(next);
        elements.add(sequenceFlow);
        // 下一个节点
        if (Objects.nonNull(next)) {
            next.setBranchId(this.getBranchId());
            List<FlowElement> flowElements = next.convert();
            elements.addAll(flowElements);
        }
        return elements;
    }
}
